;=========================================================================
;------------------------------------------------------------------
; The Interrupt 21h Direct Console Input function returns a normal
; key as a character code and an extended key as a scan code.
;------------------------------------------------------------------

KEY_ESC   equ 1Bh     ; character code for Escape key
KEY_LEFT  equ 4Bh     ; scan code for Left key
KEY_RIGHT equ 4Dh     ; scan code for Right key

;=========================================================================
.model small
.386
.stack
.data
    col     db 0
    bat$    db " ____ $"
.code
.startup
;=========================================================================

    ;-----------------------------------------------------------------
    ; Set the keyboard typematic delay to the minimum (250ms) and the
    ; typematic rate to the maximum (30 characters per second).
    ;-----------------------------------------------------------------

    mov ax, 305h
    xor bx, bx
    int 16h

    ;----------------------------
    ; Make the cursor invisible.
    ;----------------------------

    mov ah, 1
    mov ch, 00100000b
    int 10h

  @@:

    ;-----------------------------------------------
    ; Set the cursor position to row 23, column col.
    ;-----------------------------------------------

    mov ah, 2
    mov bh, 0
    mov dh, 23
    mov dl, col
    int 10h

    ;------------------
    ; Display the bat.
    ;------------------

    mov ah, 9
    mov dx, OFFSET bat$
    int 21h

    ;-----------------------------------------------
    ; Get input and update the cursor column value.
    ;-----------------------------------------------

    mov ah, 6
    mov dl, 0ffh
    int 21h
    jz  @B
    .IF al == KEY_ESC
        jmp @F
    .ELSEIF al == KEY_LEFT
        .IF col > 0
            dec col
        .ENDIF
    .ELSEIF al == KEY_RIGHT
        .IF col < 74
            inc col
        .ENDIF
    .ENDIF
    jmp @B

  @@:
;=========================================================================
.exit
end

