;=========================================================================
SC_ESC   equ 1      ; scan code for Escape key
SC_LEFT  equ 4Bh    ; scan code for Left key
SC_RIGHT equ 4Dh    ; scan code for Right key
;=========================================================================
.model small, c
.386

include mstimer.asm
include multikey.asm

.stack
.data
    col     db 0
    bat$    db " ____ $"
.code
;=========================================================================
.startup
;=========================================================================

    call StartMsTimer
    call StartMultikey

    ;----------------------------
    ; Make the cursor invisible.
    ;----------------------------

    mov ah, 1
    mov ch, 00100000b
    int 10h

  @@:

    ;-----------------------------------------------
    ; Set the cursor position to row 23, column col.
    ;-----------------------------------------------

    mov ah, 2
    mov bh, 0
    mov dh, 23
    mov dl, col
    int 10h

    ;------------------
    ; Display the bat.
    ;------------------

    mov ah, 9
    mov dx, OFFSET bat$
    int 21h

    ;-----------------------------------------------
    ; Get input and update the cursor column value.
    ;-----------------------------------------------

    .IF keyState+SC_ESC
        jmp @F
    .endif
    .IF keyState+SC_LEFT
        .IF col > 0
            dec col
        .ENDIF
    .endif
    .IF keyState+SC_RIGHT
        .IF col < 74
            inc col
        .ENDIF
    .ENDIF

    invoke sleep, 20

    jmp @B

  @@:

    call StopMsTimer
    call StopMultikey

;=========================================================================
.exit
end

